unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  MyFunc, JwwGaibu ;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Button3: TButton;
    ListBox1: TListBox;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
    AppPath : string ;
    OKflag : Boolean ;
    Xsize,Ysize : double ;
    ALmode : integer ;
    ZSmode : integer ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// N
procedure TForm1.FormShow(Sender: TObject);
var
   F : TextFile ;
   s : string ;
   i,j : integer ;
begin
   OKflag := False ;
   Xsize := 0.0 ;
   Ysize := 0.0 ;
   ALmode := 2 ;
   ZSmode := 0 ;
   ListBox1.Items.Clear ;
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // ʒu񓙂ǂݍ
   if (FileExists(AppPath+'p024.dat')) then begin
      try
         AssignFile(F, AppPath+'p024.dat');
         FileMode := 0;
         Reset(F);
         ReadLn(F, s);  Form1.Left := SInt(s);
         ReadLn(F, s);  Form1.Top  := SInt(s);
         ReadLn(F, s);  Xsize := SDbl(s);
         ReadLn(F, s);  Ysize := SDbl(s);
         ReadLn(F, s);  ALmode:= SInt(s);
         ReadLn(F, s);  ZSmode:= SInt(s);
         ReadLn(F, s);  j := SInt(s);
         for i:=1 to j do begin
            ReadLn(F, s);
            ListBox1.Items.Add(s);
         end;
         CloseFile(F);
      except
         CloseFile(F);
      end;
   end;
   Edit1.text := FloatToStr(Xsize);
   Edit2.text := FloatToStr(Ysize);
   RadioGroup1.ItemIndex := ALmode;
   RadioGroup2.ItemIndex := ZSmode;
   // JWC_TEMP.TXTJ܂
   OpenTempFile(AppPath+'JWC_TEMP.TXT') ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
   F : TextFile ;
   s : string ;
   x1,y1,x2,y2 : double ;
   w1,w2,w3,w4 : double ;
   i,j : integer ;
begin
   ALmode := RadioGroup1.ItemIndex ;
   ZSmode := RadioGroup2.ItemIndex ;
   // ʒu񓙂ۑ
   try
      AssignFile(F, AppPath+'p024.dat');
      ReWrite(F);
      WriteLn(F, IntToStr(Form1.Left));
      WriteLn(F, IntToStr(Form1.Top));
      WriteLn(F, FloatToStr(Xsize));
      WriteLn(F, FloatToStr(Ysize));
      WriteLn(F, IntToStr(ALmode));
      WriteLn(F, IntToStr(ZSmode));
      j := ListBox1.Items.Count ;
      WriteLn(F, IntToStr(j));
      for i:=0 to j-1 do begin
         s := ListBox1.Items[i] ;
         WriteLn(F, s);
      end;
      CloseFile(F);
   except
      CloseFile(F);
   end;
   // JWC_TEMP.TXT㏑ۑ܂
   try
      AssignFile(F, AppPath+'JWC_TEMP.TXT');
      ReWrite(F);
      if (OKflag) then begin
         // [OK]
         x1 := 0.0;
         y1 := 0.0;
         case(ALmode)of
         0: begin // 
               x1 := 0.0;
               y1 :=-Ysize;
            end;
         1: begin // 
               x1 := 0.0;
               y1 :=-Ysize/2.0;
            end;
         2: begin // 
               x1 := 0.0;
               y1 := 0.0;
            end;
         3: begin // 
               x1 :=-Xsize/2.0;
               y1 :=-Ysize;
            end;
         4: begin // 
               x1 :=-Xsize/2.0;
               y1 :=-Ysize/2.0;
            end;
         5: begin // 
               x1 :=-Xsize/2.0;
               y1 := 0.0;
            end;
         6: begin // E
               x1 :=-Xsize;
               y1 :=-Ysize;
            end;
         7: begin // E
               x1 :=-Xsize;
               y1 :=-Ysize/2.0;
            end;
         8: begin // E
               x1 :=-Xsize;
               y1 := 0.0;
            end;
         end;
         x2 := x1 + Xsize;
         y2 := y1 + Ysize;
         if (ZSmode = 1) then
            WriteLn(F, 'bz');
         Rev(w1,w2, x1,y1, 0.0,0.0, JG_Jikukaku);
         Rev(w3,w4, x2,y1, 0.0,0.0, JG_Jikukaku);
         s := FloatToStr(w1) + ' ' + FloatToStr(w2) + ' ' + FloatToStr(w3) + ' ' + FloatToStr(w4);
         WriteLn(F, s);
         w1 := w3 ;
         w2 := w4 ;
         Rev(w3,w4, x2,y2, 0.0,0.0, JG_Jikukaku);
         s := FloatToStr(w1) + ' ' + FloatToStr(w2) + ' ' + FloatToStr(w3) + ' ' + FloatToStr(w4);
         WriteLn(F, s);
         w1 := w3 ;
         w2 := w4 ;
         Rev(w3,w4, x1,y2, 0.0,0.0, JG_Jikukaku);
         s := FloatToStr(w1) + ' ' + FloatToStr(w2) + ' ' + FloatToStr(w3) + ' ' + FloatToStr(w4);
         WriteLn(F, s);
         w1 := w3 ;
         w2 := w4 ;
         Rev(w3,w4, x1,y1, 0.0,0.0, JG_Jikukaku);
         s := FloatToStr(w1) + ' ' + FloatToStr(w2) + ' ' + FloatToStr(w3) + ' ' + FloatToStr(w4);
         WriteLn(F, s);
      end
      else begin
         // [LZ]
         WriteLn(F, 'hq');
      end;
      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// [OK]
procedure TForm1.Button1Click(Sender: TObject);
begin
   Xsize := SDbl(Edit1.Text) ;
   Ysize := SDbl(Edit2.Text) ;
   if (Xsize <= 0.0) then begin
      MessageBeep(Word(-1));
      ShowMessage('TCY[ȉ̐lɂȂĂ܂Bē͂ĉB');
      exit ;
   end;
   if (Ysize <= 0.0) then begin
      MessageBeep(Word(-1));
      ShowMessage('cTCY[ȉ̐lɂȂĂ܂Bē͂ĉB');
      exit ;
   end;

   OKflag := True ;
   Close ;
end;

// [LZ]
procedure TForm1.Button2Click(Sender: TObject);
begin
   OKflag := False ;
   Close ;
end;

// [o^]
procedure TForm1.Button3Click(Sender: TObject);
var
   s : string ;
   i : integer ;
begin
   s := FloatToStr(SDbl(Edit1.Text)) + ','
      + FloatToStr(SDbl(Edit2.Text)) + '|';
   i := RadioGroup2.ItemIndex;
   if (i = 0) then
      s := s + '|'
   else
      s := s + '}|';
   i := RadioGroup1.ItemIndex;
   Case(i)of
   0: s := s + '';
   1: s := s + '';
   2: s := s + '';
   3: s := s + '';
   4: s := s + '';
   5: s := s + '';
   6: s := s + 'E';
   7: s := s + 'E';
   8: s := s + 'E';
   end;
   ListBox1.Items.Add(s);
end;

// [폜]
procedure TForm1.Button4Click(Sender: TObject);
var
   i : integer ;
begin
   if (ListBox1.Items.Count = 0) then exit ;
   i := ListBox1.ItemIndex ;
   if (i >= 0) then
      ListBox1.Items.Delete(i);
end;

// [I]
procedure TForm1.ListBox1Click(Sender: TObject);
var
   i : integer ;
   s,t : string ;
begin
   if (ListBox1.Items.Count = 0) then exit ;
   i := ListBox1.ItemIndex ;
   if (i >= 0) then begin
      s := ListBox1.Items[i] ;
      i := AnsiPos(',',s);
      t := Copy(s,1,i-1) ;
      s := Copy(s,i+1,Length(s));
      Edit1.Text := t ;
      i := AnsiPos('|',s);
      t := Copy(s,1,i-1) ;
      s := Copy(s,i+1,Length(s));
      Edit2.Text := t ;
      i := AnsiPos('|',s);
      t := Copy(s,1,i-1) ;
      s := Copy(s,i+1,Length(s));
      if (t = '') then
         RadioGroup2.ItemIndex := 0
      else
         RadioGroup2.ItemIndex := 1;
      i := 2;
      if (s = '') then i:=0
      else if (s = '') then i:=1
      else if (s = '') then i:=2
      else if (s = '') then i:=3
      else if (s = '') then i:=4
      else if (s = '') then i:=5
      else if (s = 'E') then i:=6
      else if (s = 'E') then i:=7
      else if (s = 'E') then i:=8;
      RadioGroup1.ItemIndex := i;
   end;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Key = VK_UP)or(Key = VK_DOWN) then
      ListBox1.SetFocus ;
end;

end.
